// C Source File
// Created 3/8/2003; 11:29:57 AM

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define RETURN_VALUE          // Return Pushed Expression
#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.01 or higher

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
	ESI  eq;
	
	if(ArgCount() == 0) {
		ER_throw(ER_TOO_FEW_ARGS);
		return;
	}
	
	if(ArgCount() > 1) {
		ER_throw(ER_TOO_MANY_ARGS);
		return;
	}
	
	if(GetArgType(EX_getArg(0)) != 135){
		ER_throw(ER_ARGUMENT);
		return;
	}
	
	//replace y with y(x) and differentiate
	eq = top_estack;
	push_END_TAG();
	push_quantum(VAR_X_TAG);
	push_parse_text("f(x)");
	push_quantum_pair(VAR_Y_TAG,EQ_TAG);
	push_expr_quantum(eq,WITH_TAG);
	push_quantum(DIFFERENTIATE_TAG);
	push_internal_simplify(top_estack);
	
	//replace df(x)/dx with df(z)/dz and solve for it
	eq = top_estack;
	push_END_TAG();
	push_quantum(VAR_Z_TAG);
	push_parse_text("f(z)");
	push_quantum(DIFFERENTIATE_TAG);
	push_END_TAG();
	push_quantum(VAR_X_TAG);
	push_parse_text("f(x)");
	push_quantum(DIFFERENTIATE_TAG);
	push_quantum(EQ_TAG);
	push_expr_quantum(eq,WITH_TAG);
	eq = top_estack;
	push_END_TAG();
	push_quantum(VAR_Z_TAG);
	push_expr_quantum(eq,SOLVE_TAG);
	push_internal_simplify(top_estack);
	
	// Replace df(z)/dz with df(x)/dx
	eq = top_estack;
	push_END_TAG();
	push_quantum(VAR_X_TAG);
	push_parse_text("f(x)");
	push_quantum(DIFFERENTIATE_TAG);
	push_END_TAG();
	push_quantum(VAR_Z_TAG);
	push_parse_text("f(z)");
	push_quantum(DIFFERENTIATE_TAG);
	push_quantum(EQ_TAG);
	push_expr_quantum( eq, WITH_TAG );
	push_internal_simplify( top_estack );
	
	//return f(x) to y
	eq = top_estack;
	push_END_TAG();													
	push_quantum(VAR_Y_TAG);
	push_parse_text("f(x)");
	push_quantum(EQ_TAG);
	push_expr_quantum( eq, WITH_TAG );
	push_internal_simplify( top_estack );
}
